
#include <assert.h>
#include <string.h>
#include <stdio.h>

#include "tweet.h"

int test_creacion()
{
  tweet * t = new_tweet();

  destroy_tweet(t);

  return 1;
}

int test_set_get_id()
{
  long long int id = 123;
  long long int id0, id2;

  tweet * t = new_tweet();

  id0 = get_tweet_id(t);

  set_tweet_id(t, id);
  id2 = get_tweet_id(t);

  destroy_tweet(t);

  return id0 == NULL_ID && id == id2 ? 1 : 0;
}

int test_set_get_text()
{
  char text[] = {"Supercalifragislisticuespialidoso"};
  int ret;

  tweet * t = new_tweet();

  set_tweet_text(t, text);
  ret = strcmp(get_tweet_text(t), text);

  destroy_tweet(t);

  return ret==0 ? 1 : 0;
}

int test_set_get_author()
{
  int ret;
  void *author;

  tweet * t = new_tweet();

  author = get_tweet_author(t);

  set_tweet_author(t, (twittero *)1);
  ret = (long long int)get_tweet_author(t);

  destroy_tweet(t);

  return author==NULL && ret==1 ? 1 : 0;
}

int test_print()
{
  tweet * t = new_tweet();

  set_tweet_id(t, 1);
  set_tweet_text(t, "Hola mundo");
  print_tweet(t);

  destroy_tweet(t);

  return 1;
}

/**
 * Funcion main de test 
 *
 */
int main(int argn, char**argv) 
{

  assert(test_creacion());
  assert(test_set_get_id());
  assert(test_set_get_text());
  assert(test_set_get_author());
  assert(test_print());

  printf("tweet.c OK\n");

  return 0;
}
