
#include <assert.h>
#include <string.h>
#include <stdio.h>

#include "tweet.h"
#include "tweets.h"
#include "const.h"

void add_tweets(tweets *aa, int n, int with_ids)
{ 
  int i;
  char *texts[] = {"Supercalifragilisticuespialidoso", "Hola mundo"};
  tweet * a;

  for(i = 0; i < n; i++) {
    a = new_tweet();
    if (with_ids) {
      set_tweet_id(a, i+1);
    }
    set_tweet_text(a, texts[i%2]);
    add_tweet(aa, a);
  }

}

int test_creacion()
{
  tweets * aa = new_tweets();

  destroy_tweets(aa);

  return 1;
}

int test_add_simple()
{
  tweet *a;
  tweets * aa = new_tweets();

  add_tweets(aa, 1, FALSE);
  if (1 != get_n_tweets(aa)) {
    return 0;
  }

  a = get_tweet_i(aa, 0);
  if (a == NULL) {
    return 0;
  }

  destroy_tweet(a);
  destroy_tweets(aa);

  return 1;
}

int test_get_tweet_by_id(int with_ids)
{
  int i;
  int ok;
  tweet *a;
  tweets * aa = new_tweets();

  add_tweets(aa, 10, with_ids ? TRUE : FALSE);

  ok = 1;
  for( i = get_n_tweets(aa)-1; i>=0; i--) {
    if (NULL==(a=get_tweet_by_id(aa, i+1))) {
      printf("ERROR: No se encuentra el tweet con id %d\n", i+1);
      ok = 0;
      break;
    }
    else if (get_tweet_id(a)!=i+1) {
      printf("ERROR: tweet encontrado con id distinto al pedido\n");
      ok = 0;
      break;
    }
  }

  for( i = get_n_tweets(aa)-1; i>=0; i--) {
    a=get_tweet_i(aa, i);
    destroy_tweet(a);
  }

  destroy_tweets(aa);

  return ok;
}


int test_print()
{
  tweets * aa = new_tweets();

  print_tweets(aa);

  destroy_tweets(aa);

  return 1;
}

/**
 * Funcion main de test 
 *
 */
int main(int argn, char**argv) 
{
  assert(test_creacion());
  assert(test_add_simple());
  assert(test_get_tweet_by_id(FALSE));
  assert(test_get_tweet_by_id(TRUE));
  assert(test_print());

  printf("tweets.c OK\n");

  return 0;
}
