
#include <assert.h>
#include <string.h>
#include <stdio.h>

#include "twittero.h"
#include "const.h"

int test_creacion()
{
  twittero * user = new_twittero();

  destroy_twittero(user);

  return 1;
}

int test_set_get_id()
{
  int id = 123;
  int id0, id2;

  twittero * user = new_twittero();
  
  id0 = get_twittero_id(user);

  set_twittero_id(user, id);
  id2 = get_twittero_id(user);

  destroy_twittero(user);

  return id0 == NULL_ID && id == id2 ? 1 : 0;
}

int test_set_get_alias()
{
  char txt[] = {"pepeperez"};
  int ret;

  twittero * user = new_twittero();

  set_twittero_alias(user, txt);
  ret = strcmp(get_twittero_alias(user), txt);

  destroy_twittero(user);

  return ret==0 ? 1 : 0;
}

int test_set_get_name()
{
  char txt[] = {"Pepe Perez"};
  int ret;

  twittero * user = new_twittero();

  set_twittero_name(user, txt);
  ret = strcmp(get_twittero_name(user), txt);

  destroy_twittero(user);

  return ret==0 ? 1 : 0;
}


int test_twittero_tweets()
{
  twittero * user;
  tweet *t1, *t2, *t3;
  BOOL ret1, ret2, ret3, ret4, ret5, ret6;

  user = new_twittero();

  set_twittero_id(user, 1);
  set_twittero_alias(user, "pepeperez");

  t1 = new_tweet();
  set_tweet_id(t1,1);
  set_tweet_text(t1,"Hola mundo");
  add_twittero_tweet(user, t1);
   
  t2 = new_tweet();
  set_tweet_id(t2,2);
  set_tweet_text(t2,"Hola de nuevo");
  add_twittero_tweet(user, t2);

  ret1 = has_twittero_tweet(user, t1);
  ret2 = has_twittero_tweet(user, t2);
  ret4 = user==get_tweet_author(t1) ? TRUE : FALSE;
  ret5 = user==get_tweet_author(t2) ? TRUE : FALSE;
  
  t3 = new_tweet();
  set_tweet_id(t3,3);
  set_tweet_text(t3,"Hola hola");

  ret3 = has_twittero_tweet(user, t3);
  ret6 = user==get_tweet_author(t3) ? FALSE : TRUE;

  destroy_twittero(user);
  destroy_tweet(t1);
  destroy_tweet(t2);
  destroy_tweet(t3);

  return ret1==TRUE && ret2==TRUE && ret3==FALSE && ret4 && ret5 && ret6; 
}

int test_print()
{
  twittero * user = new_twittero();

  set_twittero_id(user, 1);
  set_twittero_alias(user, "pepeperez");
  set_twittero_name(user, "Pepe Perez");
  print_twittero(user);

  destroy_twittero(user);

  return 1;
}

/**
 * Funcion main de test 
 *
 */
int main(int argn, char**argv) 
{

  assert(test_creacion());
  assert(test_set_get_id());
  assert(test_set_get_alias());
  assert(test_set_get_name());
  assert(test_twittero_tweets());
  assert(test_print());

  printf("twittero.c OK\n");

  return 0;
}
