/**
 * Fichero : tweets.h      Fecha:23/12/2014
 * Autores:                                   
 *                                            
 *  fichero con la cabecera del TAD tweets
 *                                            
 */

/*#include "twittero.h"*/

#ifndef __TWEETS_H_
#define __TWEETS_H_

#include "tweet.h"

/*********************************************** Estructura del TAD tweets ***/
typedef struct _tweets tweets;

/**
 * Funcion para crear una nueva estructura tweet 
 *
 * Entrada:
 *
 * Salida:
 *    Una estructura tweets inicializado todo a vacio o NULL en caso de error
 */
tweets * new_tweets();

/**
 * Funcion para liberar la memoria reservada de la estructura tweets y todos los
 *   tweetes que estan en el array.
 *
 * Entrada:
 *    Estructura tweets a liberar
 */
void destroy_tweets(tweets *tts);

/**
 * Funcion para aniadir un tweet ya creado al array 
 *
 * Entrada:
 *    Estructura del TAD tweets sobre el que se quiere aniadir un tweet y
 *    puntero al tweet a aniadir. Si el tweet tiene un ID_NULO se le asignara
 *    el valor del last_id+1
 *
 * Salida:
 *    El id del tweet insertado o -1 en caso de error
 */
int add_tweet(tweets * tts, tweet * t);

/**
 * Funcion para recuperar el numero de tweetes del array
 *
 * Entrada:
 *    Estructura del TAD tweets sobre el que se quiere recuperar su tamanio
 *
 * Salida:
 *    El numero de tweetes
 */
int get_n_tweets(tweets * tts);

/**
 * Funcion para recuperar el tweet n-esimo de la lista
 *
 * Entrada:
 *    Estructura tweets e indice del tweet a recuperar (indexado sobre 0)
 *
 * Salida:
 *    Un puntero al tweet o NULL si hay un error
 */
tweet * get_tweet_i(tweets * tts, int index);


/**
 * Funcion para recuperar un tweet dado su código.
 *
 * Entrada:
 *    Colección de tweetes y el código del tweet a recuperar.
 *
 * Salida:
 *    Un puntero al tweet o NULL si no se encuentra.
 */
tweet * get_tweet_by_id(tweets *tts, long long int id);

/**
 * Funcion para imprimir la lista de tweetes por pantalla
 *
 * Entrada:
 *    Estructura TAD twittero a imprimir
 */
void print_tweets(tweets *tts); 

#endif

